#include "BehaviourCoin.h"
#include "Level.h"
#include "LD.h"



BehaviourCoin::BehaviourCoin()
{
  m_Angle = (float)( rand() % 360 );
  m_DistanceToMove = 50;
}



float ReflectAngle( const float fSurfaceNormalAngle, const float fIncomingAngle )
{
  return 2 * fSurfaceNormalAngle - fIncomingAngle + 180.0f;
}




void BehaviourCoin::UpdateFixed( Level& Level, GameObject* pObj )
{

  if ( m_DistanceToMove >= 0 )
  {
    int blocked = Level.WalkObject( pObj, (int)( 2.0f * cosf( 3.1415926f / 180.0f * m_Angle ) ), (int)( 2.0f * sinf( 3.1415926f / 180.0f * m_Angle ) ) );

    if ( blocked & 1 )
    {
      pObj->m_Angle = ReflectAngle( 90.0f, pObj->m_Angle );
    }
    if ( blocked & 2 )
    {
      pObj->m_Angle = ReflectAngle( 0.0f, pObj->m_Angle );
    }

    --m_DistanceToMove;
  }
  /*
  else
  {
    Level.MoveObject( pObj, pObj->m_X + m_WalkDX, pObj->m_Y + m_WalkDY );
    --m_DistanceToWalk;
  }*/

}



void BehaviourCoin::Update( Level& Level, float ElapsedTime, GameObject* pObj )
{
}
