#include "BehaviourKillable.h"
#include "BehaviourPlayer.h"
#include "Level.h"
#include "LD.h"



BehaviourKillable::BehaviourKillable( int HP )
{
  m_Hits = HP;
  m_MaxHits = HP;
  m_HitDelay = 0;
}



void BehaviourKillable::UpdateFixed( Level& Level, GameObject* pObj )
{

  if ( m_HitDelay > 0 )
  {
    --m_HitDelay;
  }

}



void BehaviourKillable::OnEvent( Level& Level, const std::string& Event, GameObject* pObj, GameObject* pOtherObject )
{
  if ( Event == "Hit" )
  {
    if ( m_HitDelay == 0 )
    {
      m_HitDelay = 20;
      --m_Hits;
      if ( pObj->m_Type == LD::OT_PLAYER )
      {
        Level.m_pPlayerBehaviour->m_HP = m_Hits;
      }
      if ( m_Hits == 0 )
      {
        pObj->OnEvent( Level, "Killed", pObj, NULL );
        pObj->m_RemoveMe = true;

        theApp.PlaySound( LD::SOUND_KILLED );
      }
      else
      {
        theApp.PlaySound( LD::SOUND_HIT );
        pObj->OnEvent( Level, "Hurt", pObj, pOtherObject );
      }
    }
  }
  else if ( Event == "Heal" )
  {
    if ( pOtherObject->m_Type == LD::OT_HEART_COLLECTABLE )
    {
      m_Hits++;
    }
    else if ( pOtherObject->m_Type == LD::OT_HEART_CONTAINER )
    {
      m_MaxHits++;
      m_Hits = m_MaxHits;
    }
    if ( m_Hits > m_MaxHits )
    {
      m_Hits = m_MaxHits;
    }
    if ( pObj->m_Type == LD::OT_PLAYER )
    {
      Level.m_pPlayerBehaviour->m_HP = m_Hits;
      Level.m_pPlayerBehaviour->m_HPMax = m_MaxHits;
    }
  }

}