#include "BehaviourShoot.h"
#include "Level.h"
#include "LD.h"



BehaviourShoot::BehaviourShoot( LD::ObjectType ShotType, int ShotDelay, int Pattern )
{
  m_ShotType = ShotType;
  m_FullShotDelay = ShotDelay;
  m_ShotPattern = Pattern;
  m_ShotPatternPos = 0;
  m_ShotDelay = m_FullShotDelay + rand() % 10;
}



void BehaviourShoot::UpdateFixed( Level& Level, GameObject* pObj )
{

  if ( m_ShotDelay > 0 )
  {
    --m_ShotDelay;
  }
  else if ( m_ShotDelay == 0 )
  {
    if ( m_ShotPattern == 0 )
    {
      m_ShotDelay = m_FullShotDelay + rand() % 10;

      GameObject* pShot = new GameObject( pObj->m_X, pObj->m_Y, m_ShotType );
      Level.AddObject( pShot );
    }
    else if ( m_ShotPattern == 1 )
    {
      m_ShotDelay = m_FullShotDelay;
      m_ShotPatternPos = 1 - m_ShotPatternPos;

      if ( m_ShotPatternPos == 0 )
      {
        GameObject* pShot = new GameObject( pObj->m_X, pObj->m_Y, m_ShotType );
        pShot->OnEvent( Level, "Move.R", pObj, NULL );
        Level.AddObject( pShot );
        pShot = new GameObject( pObj->m_X, pObj->m_Y, m_ShotType );
        pShot->OnEvent( Level, "Move.L", pObj, NULL );
        Level.AddObject( pShot );
        pShot = new GameObject( pObj->m_X, pObj->m_Y, m_ShotType );
        pShot->OnEvent( Level, "Move.U", pObj, NULL );
        Level.AddObject( pShot );
        pShot = new GameObject( pObj->m_X, pObj->m_Y, m_ShotType );
        pShot->OnEvent( Level, "Move.D", pObj, NULL );
        Level.AddObject( pShot );
      }
      else
      {
        GameObject* pShot = new GameObject( pObj->m_X, pObj->m_Y, m_ShotType );
        pShot->OnEvent( Level, "Move.UL", pObj, NULL );
        Level.AddObject( pShot );
        pShot = new GameObject( pObj->m_X, pObj->m_Y, m_ShotType );
        pShot->OnEvent( Level, "Move.UR", pObj, NULL );
        Level.AddObject( pShot );
        pShot = new GameObject( pObj->m_X, pObj->m_Y, m_ShotType );
        pShot->OnEvent( Level, "Move.DL", pObj, NULL );
        Level.AddObject( pShot );
        pShot = new GameObject( pObj->m_X, pObj->m_Y, m_ShotType );
        pShot->OnEvent( Level, "Move.DR", pObj, NULL );
        Level.AddObject( pShot );
      }
    }
    theApp.PlaySoundA( LD::SOUND_ENEMY_SHOT );
  }

}



