#ifndef LD_TYPES_H
#define LD_TYPES_H


namespace LD
{
  enum TextureTypes
  {
    TEX_TILE_DIRT,
    TEX_TILE_GRASS,
    TEX_TILE_SAND,
    TEX_TILE_ROCK,
    TEX_PLAYER_D,
    TEX_PLAYER_D_1,
    TEX_PLAYER_D_2,
    TEX_PLAYER_U,
    TEX_PLAYER_U_1,
    TEX_PLAYER_U_2,
    TEX_PLAYER_L,
    TEX_PLAYER_L_1,
    TEX_PLAYER_L_2,
    TEX_PLAYER_R,
    TEX_PLAYER_R_1,
    TEX_PLAYER_R_2,
    TEX_BUSH,
    TEX_ENTRANCE,
    TEX_OCTO_1,
    TEX_OCTO_2,
    TEX_SWORD,
    TEX_COIN_1,
    TEX_COIN_2,
    TEX_COIN_3,
    TEX_COIN_4,
    TEX_CHEST,
    TEX_CHEST_OPEN,
    TEX_AXE,
    TEX_TILE_WATER,
    TEX_TILE_BRICK,
    TEX_GREEN_BUSH,
    TEX_LEAVES,
    TEX_ENEMY_SHOT,
    TEX_HEART_FULL,
    TEX_HEART_EMPTY,
    TEX_TURRET,
    TEX_TILE_BLACK,
    TEX_LINK_1,
    TEX_LINK_2,
    TEX_FIRE_1,
    TEX_FIRE_2,
    TEX_HAMMER,
    TEX_POST,
    TEX_POST_SUNK,
    TEX_WATER_SHOES,
    TEX_GOLDEN_SWORD,
    TEX_CUBE_1,
    TEX_CUBE_2,
    TEX_HEART_CONTAINER,
    TEX_TREE,

    TEX_LAST_ENTRY
  };

  enum GameObjectType
  {
    GO_INVALID = 0,
    GO_LAST_ENTRY,
  };

  enum SoundTypes
  {
    SOUND_PICK_COIN,
    SOUND_AXE,
    SOUND_SWORD,
    SOUND_HIT,
    SOUND_KILLED,
    SOUND_HIT_BUSH,
    SOUND_PICK_ITEM,
    SOUND_ENEMY_SHOT,
    SOUND_SWITCH_WEAPON,
    SOUND_HAMMER,
    SOUND_HIT_POST,
    SOUND_CHEST_OPEN,

    SOUND_LAST_ENTRY
  };

  enum TileType
  {
    TT_GRASS,
    TT_DIRT,
    TT_SAND,
    TT_ROCK,
    TT_BRICK,
    TT_WATER,
    TT_BLACK,

    TT_LAST_ENTRY
  };

  enum ObjectType
  {
    OT_INVALID = -1,
    OT_PLAYER = 0,
    OT_BUSH,
    OT_TREE,
    OT_ENTRANCE,
    OT_OCTO,
    OT_SWORD_COLLECTABLE,
    OT_SWORD,
    OT_COIN,
    OT_CHEST,
    OT_OCTA,
    OT_AXE_COLLECTABLE,
    OT_AXE,
    OT_GREEN_BUSH,
    OT_LEAVES,
    OT_ENEMY_SHOT,
    OT_HEART_COLLECTABLE,
    OT_TURRET,
    OT_LINK,
    OT_FIRE,
    OT_HAMMER_COLLECTABLE,
    OT_HAMMER,
    OT_POST,
    OT_POST_SUNK,
    OT_WATER_SHOES,
    OT_GOLDEN_SWORD_COLLECTABLE,
    OT_GOLDEN_SWORD,
    OT_CUBE,
    OT_HEART_CONTAINER,

    OT_LAST_ENTRY
  };

}




#endif // LD_TYPES_H